=== modified file 'django/contrib/contenttypes/models.py'
--- django/contrib/contenttypes/models.py	2011-05-22 15:21:03 +0000
+++ django/contrib/contenttypes/models.py	2011-09-16 00:35:04 +0000
@@ -85,7 +85,14 @@
         unique_together = (('app_label', 'model'),)
 
     def __unicode__(self):
-        return self.name
+        # self.name is deprecated in favor of using model's verbose_name.
+        # We return self.name only when users have changed its value from the
+        # initial verbose_name_raw and might rely on it.
+        meta = self.model_class()._meta
+        if self.name != meta.verbose_name_raw:
+            return self.name
+        else:
+            return unicode(meta.verbose_name)
 
     def model_class(self):
         "Returns the Python model class for this type of content."

=== added directory 'tests/regressiontests/i18n/contenttypes'
=== added file 'tests/regressiontests/i18n/contenttypes/__init__.py'
=== added directory 'tests/regressiontests/i18n/contenttypes/locale'
=== added directory 'tests/regressiontests/i18n/contenttypes/locale/en'
=== added directory 'tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES'
=== added file 'tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.mo'
Binary files tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.mo	1970-01-01 00:00:00 +0000 and tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.mo	2011-09-16 00:09:58 +0000 differ
=== added file 'tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.po'
--- tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.po	1970-01-01 00:00:00 +0000
+++ tests/regressiontests/i18n/contenttypes/locale/en/LC_MESSAGES/django.po	2011-09-16 00:09:53 +0000
@@ -0,0 +1,26 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2011-09-15 15:41-0700\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#: models.py:6
+msgid "Anything"
+msgstr ""
+
+#: models.py:15
+msgid "Company"
+msgstr "Company"
\ No newline at end of file

=== added directory 'tests/regressiontests/i18n/contenttypes/locale/fr'
=== added directory 'tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES'
=== added file 'tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.mo'
Binary files tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.mo	1970-01-01 00:00:00 +0000 and tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.mo	2011-09-16 00:09:58 +0000 differ
=== added file 'tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.po'
--- tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.po	1970-01-01 00:00:00 +0000
+++ tests/regressiontests/i18n/contenttypes/locale/fr/LC_MESSAGES/django.po	2011-09-16 00:09:45 +0000
@@ -0,0 +1,27 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2011-09-15 15:41-0700\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=2; plural=(n > 1)\n"
+
+#: models.py:6
+msgid "Anything"
+msgstr ""
+
+#: models.py:15
+msgid "Company"
+msgstr "Société"
\ No newline at end of file

=== added file 'tests/regressiontests/i18n/contenttypes/tests.py'
--- tests/regressiontests/i18n/contenttypes/tests.py	1970-01-01 00:00:00 +0000
+++ tests/regressiontests/i18n/contenttypes/tests.py	2011-09-16 00:13:59 +0000
@@ -0,0 +1,33 @@
+# coding: utf-8
+import os
+
+from django.test import TestCase
+from django.test.utils import override_settings
+from django.utils import translation
+from django.contrib.contenttypes.models import ContentType
+
+
+class ContentTypeTests(TestCase):
+	def test_verbose_name(self):
+		company_type = ContentType.objects.get(app_label='i18n', model='company')
+		with translation.override('en'):
+			self.assertEqual(unicode(company_type), u'Company')
+		with translation.override('fr'):
+			self.assertEqual(unicode(company_type), u'Société')
+	
+	def test_field_override(self):
+		company_type = ContentType.objects.get(app_label='i18n', model='company')
+		company_type.name = 'Other'
+		self.assertEqual(unicode(company_type), 'Other')
+
+ContentTypeTests = override_settings(
+    USE_I18N=True,
+    LOCALE_PATHS=(
+        os.path.join(os.path.dirname(__file__), 'locale'),
+    ),
+    LANGUAGE_CODE='en',
+    LANGUAGES=(
+        ('en', 'English'),
+        ('fr', 'French'),
+    ),
+)(ContentTypeTests)
\ No newline at end of file

=== modified file 'tests/regressiontests/i18n/models.py'
--- tests/regressiontests/i18n/models.py	2010-09-12 19:03:39 +0000
+++ tests/regressiontests/i18n/models.py	2011-09-16 00:10:04 +0000
@@ -10,3 +10,6 @@
     date_added = models.DateTimeField(default=datetime(1799,1,31,23,59,59,0))
     cents_payed = models.DecimalField(max_digits=4, decimal_places=2)
     products_delivered = models.IntegerField()
+
+    class Meta:
+	    verbose_name = _('Company')
\ No newline at end of file

=== modified file 'tests/regressiontests/i18n/tests.py'
--- tests/regressiontests/i18n/tests.py	2011-09-08 13:25:41 +0000
+++ tests/regressiontests/i18n/tests.py	2011-09-15 22:33:45 +0000
@@ -26,6 +26,7 @@
 
 from commands.tests import *
 from patterns.tests import *
+from contenttypes.tests import *
 from test_warnings import DeprecationWarningTests
 
 here = os.path.dirname(os.path.abspath(__file__))