diff --git a/django/contrib/admin/actions.py b/django/contrib/admin/actions.py
index 5b56402..0621406 100644
--- a/django/contrib/admin/actions.py
+++ b/django/contrib/admin/actions.py
@@ -3,6 +3,7 @@ Built-in, globally-available admin actions.
 """
 
 from django.core.exceptions import PermissionDenied
+from django.contrib import messages
 from django.contrib.admin import helpers
 from django.contrib.admin.util import get_deleted_objects, model_ngettext
 from django.db import router
@@ -47,7 +48,7 @@ def delete_selected(modeladmin, request, queryset):
             queryset.delete()
             modeladmin.message_user(request, _("Successfully deleted %(count)d %(items)s.") % {
                 "count": n, "items": model_ngettext(modeladmin.opts, n)
-            })
+            }, messages.SUCCESS)
         # Return None to display the change list page again.
         return None
 
diff --git a/django/contrib/admin/options.py b/django/contrib/admin/options.py
index 2071792..b738b78 100644
--- a/django/contrib/admin/options.py
+++ b/django/contrib/admin/options.py
@@ -688,12 +688,12 @@ class ModelAdmin(BaseModelAdmin):
         change_message = ' '.join(change_message)
         return change_message or _('No fields changed.')
 
-    def message_user(self, request, message):
+    def message_user(self, request, message, level=messages.INFO):
         """
         Send a message to the user. The default implementation
         posts a message using the django.contrib.messages backend.
         """
-        messages.info(request, message)
+        messages.add_message(request, level, message)
 
     def save_form(self, request, form, change):
         """
@@ -773,7 +773,7 @@ class ModelAdmin(BaseModelAdmin):
         # Here, we distinguish between different save types by checking for
         # the presence of keys in request.POST.
         if "_continue" in request.POST:
-            self.message_user(request, msg + ' ' + _("You may edit it again below."))
+            self.message_user(request, msg + ' ' + _("You may edit it again below."), messages.SUCCESS)
             if "_popup" in request.POST:
                 post_url_continue += "?_popup=1"
             return HttpResponseRedirect(post_url_continue % pk_value)
@@ -785,10 +785,10 @@ class ModelAdmin(BaseModelAdmin):
                 # escape() calls force_unicode.
                 (escape(pk_value), escapejs(obj)))
         elif "_addanother" in request.POST:
-            self.message_user(request, msg + ' ' + (_("You may add another %s below.") % force_unicode(opts.verbose_name)))
+            self.message_user(request, msg + ' ' + (_("You may add another %s below.") % force_unicode(opts.verbose_name)), messages.SUCCESS)
             return HttpResponseRedirect(request.path)
         else:
-            self.message_user(request, msg)
+            self.message_user(request, msg, messages.SUCCESS)
 
             # Figure out where to redirect. If the user has change permission,
             # redirect to the change-list page for this object. Otherwise,
@@ -821,25 +821,25 @@ class ModelAdmin(BaseModelAdmin):
 
         msg = _('The %(name)s "%(obj)s" was changed successfully.') % {'name': force_unicode(verbose_name), 'obj': force_unicode(obj)}
         if "_continue" in request.POST:
-            self.message_user(request, msg + ' ' + _("You may edit it again below."))
+            self.message_user(request, msg + ' ' + _("You may edit it again below."), messages.SUCCESS)
             if "_popup" in request.REQUEST:
                 return HttpResponseRedirect(request.path + "?_popup=1")
             else:
                 return HttpResponseRedirect(request.path)
         elif "_saveasnew" in request.POST:
             msg = _('The %(name)s "%(obj)s" was added successfully. You may edit it again below.') % {'name': force_unicode(verbose_name), 'obj': obj}
-            self.message_user(request, msg)
+            self.message_user(request, msg, messages.SUCCESS)
             return HttpResponseRedirect(reverse('admin:%s_%s_change' %
                                         (opts.app_label, module_name),
                                         args=(pk_value,),
                                         current_app=self.admin_site.name))
         elif "_addanother" in request.POST:
-            self.message_user(request, msg + ' ' + (_("You may add another %s below.") % force_unicode(verbose_name)))
+            self.message_user(request, msg + ' ' + (_("You may add another %s below.") % force_unicode(verbose_name)), messages.SUCCESS)
             return HttpResponseRedirect(reverse('admin:%s_%s_add' %
                                         (opts.app_label, module_name),
                                         current_app=self.admin_site.name))
         else:
-            self.message_user(request, msg)
+            self.message_user(request, msg, messages.SUCCESS)
             # Figure out where to redirect. If the user has change permission,
             # redirect to the change-list page for this object. Otherwise,
             # redirect to the admin index.
@@ -898,7 +898,7 @@ class ModelAdmin(BaseModelAdmin):
                 # Reminder that something needs to be selected or nothing will happen
                 msg = _("Items must be selected in order to perform "
                         "actions on them. No items have been changed.")
-                self.message_user(request, msg)
+                self.message_user(request, msg, messages.ERROR)
                 return None
 
             if not select_across:
@@ -916,7 +916,7 @@ class ModelAdmin(BaseModelAdmin):
                 return HttpResponseRedirect(request.get_full_path())
         else:
             msg = _("No action selected.")
-            self.message_user(request, msg)
+            self.message_user(request, msg, messages.ERROR)
             return None
 
     @csrf_protect_m
@@ -1158,7 +1158,7 @@ class ModelAdmin(BaseModelAdmin):
             else:
                 msg = _("Items must be selected in order to perform "
                         "actions on them. No items have been changed.")
-                self.message_user(request, msg)
+                self.message_user(request, msg, messages.ERROR)
                 action_failed = True
 
         # Actions with confirmation
@@ -1203,7 +1203,7 @@ class ModelAdmin(BaseModelAdmin):
                                     changecount) % {'count': changecount,
                                                     'name': name,
                                                     'obj': force_unicode(obj)}
-                    self.message_user(request, msg)
+                    self.message_user(request, msg, messages.SUCCESS)
 
                 return HttpResponseRedirect(request.get_full_path())
 
@@ -1280,7 +1280,10 @@ class ModelAdmin(BaseModelAdmin):
             self.log_deletion(request, obj, obj_display)
             self.delete_model(request, obj)
 
-            self.message_user(request, _('The %(name)s "%(obj)s" was deleted successfully.') % {'name': force_unicode(opts.verbose_name), 'obj': force_unicode(obj_display)})
+            self.message_user(request, _('The %(name)s "%(obj)s" was deleted successfully.') % {
+                'name': force_unicode(opts.verbose_name),
+                'obj': force_unicode(obj_display)
+            }, messages.SUCCESS)
 
             if not self.has_change_permission(request, None):
                 return HttpResponseRedirect(reverse('admin:index',
diff --git a/django/contrib/admin/static/admin/img/icon_alert.gif b/django/contrib/admin/static/admin/img/icon_alert.gif
index a1dde26..0765aa8 100644
Binary files a/django/contrib/admin/static/admin/img/icon_alert.gif and b/django/contrib/admin/static/admin/img/icon_alert.gif differ
diff --git a/django/contrib/comments/admin.py b/django/contrib/comments/admin.py
index 4cb9066..e74c99c 100644
--- a/django/contrib/comments/admin.py
+++ b/django/contrib/comments/admin.py
@@ -1,4 +1,4 @@
-from django.contrib import admin
+from django.contrib import admin, messages
 from django.contrib.comments.models import Comment
 from django.utils.translation import ugettext_lazy as _, ungettext
 from django.contrib.comments import get_model
@@ -65,7 +65,7 @@ class CommentsAdmin(admin.ModelAdmin):
         msg = ungettext(u'1 comment was successfully %(action)s.',
                         u'%(count)s comments were successfully %(action)s.',
                         n_comments)
-        self.message_user(request, msg % {'count': n_comments, 'action': done_message(n_comments)})
+        self.message_user(request, msg % {'count': n_comments, 'action': done_message(n_comments)}, messages.SUCCESS)
 
 # Only register the default admin if the model is the built-in comment model
 # (this won't be true if there's a custom comment app).
diff --git a/tests/regressiontests/admin_views/tests.py b/tests/regressiontests/admin_views/tests.py
index 0be8b36..47858f7 100644
--- a/tests/regressiontests/admin_views/tests.py
+++ b/tests/regressiontests/admin_views/tests.py
@@ -2103,7 +2103,6 @@ class AdminInheritedInlinesTest(TestCase):
         bar_id = BarAccount.objects.all()[0].id
 
         # test the edit case
-
         response = self.client.get('/test_admin/admin/admin_views/persona/%d/' % persona_id)
         names = name_re.findall(response.content)
         # make sure we have no duplicate HTML names
@@ -2322,7 +2321,7 @@ class AdminActionsTest(TestCase):
         }
         response = self.client.post('/test_admin/admin/admin_views/subscriber/', action_data)
         msg = """Items must be selected in order to perform actions on them. No items have been changed."""
-        self.assertContains(response, msg)
+        self.assertContains(response, '<li class="error">' + msg + '</li>', html=True)
         self.assertEqual(Subscriber.objects.count(), 2)
 
     def test_user_message_on_no_action(self):
@@ -2336,7 +2335,7 @@ class AdminActionsTest(TestCase):
         }
         response = self.client.post('/test_admin/admin/admin_views/subscriber/', action_data)
         msg = """No action selected."""
-        self.assertContains(response, msg)
+        self.assertContains(response, '<li class="error">' + msg + '</li>', html=True)
         self.assertEqual(Subscriber.objects.count(), 2)
 
     def test_selection_counter(self):
@@ -2377,6 +2376,7 @@ class TestCustomChangeList(TestCase):
         self.assertEqual(response.status_code, 302) # redirect somewhere
         # Hit the page once to get messages out of the queue message list
         response = self.client.get('/test_admin/%s/admin_views/gadget/' % self.urlbit)
+        self.assertContains(response, '<li class="success">The gadget &quot;First Gadget&quot; was added successfully.</li>', html=True)
         # Ensure that that data is still not visible on the page
         response = self.client.get('/test_admin/%s/admin_views/gadget/' % self.urlbit)
         self.assertEqual(response.status_code, 200)
@@ -2439,7 +2439,7 @@ class AdminCustomQuerysetTest(TestCase):
                 post_data, follow=True)
         self.assertEqual(response.status_code, 200)
         # Message should contain non-ugly model name. Instance representation is set by unicode() (ugly)
-        self.assertContains(response, '<li class="info">The paper &quot;Paper_Deferred_author object&quot; was changed successfully.</li>', html=True)
+        self.assertContains(response, '<li class="success">The paper &quot;Paper_Deferred_author object&quot; was changed successfully.</li>', html=True)
 
         # defer() is used in ModelAdmin.queryset()
         cl = CoverLetter.objects.create(author=u"John Doe")
@@ -2454,7 +2454,7 @@ class AdminCustomQuerysetTest(TestCase):
                 post_data, follow=True)
         self.assertEqual(response.status_code, 200)
         # Message should contain non-ugly model name. Instance representation is set by model's __unicode__()
-        self.assertContains(response, '<li class="info">The cover letter &quot;John Doe II&quot; was changed successfully.</li>', html=True)
+        self.assertContains(response, '<li class="success">The cover letter &quot;John Doe II&quot; was changed successfully.</li>', html=True)
 
 class AdminInlineFileUploadTest(TestCase):
     urls = "regressiontests.admin_views.urls"